LIBRARY "AASM.LIB"
PUBDOC	"DE(16bit) * HL(16bit) = DE,HL(32bit)"
PUBLIC	MUL16:
	PUSH	IX
	PUSH	IY
	PUSH	DE
	POP		BC
	LD		DE,0
	LD		IX,0
	LD		IY,0
	LD		A,16		; 16 bit
MUL16_1:
	SRL		B
	RR		C
	JR		NC,MUL16_2
	PUSH	DE
	PUSH	HL
	CALL	ADD32
	PUSH	DE
	POP		IX
	PUSH	HL
	POP		IY
	POP		HL
	POP		DE
MUL16_2:
	SLA		L
	RL		H
	RL		E
	RL		D
	DEC		A
	JR		NZ,MUL16_1
	PUSH	IX
	POP		DE
	PUSH	IY
	POP		HL
	POP		IY
	POP		IX
	RET
