#include	<stdio.h>
#include	<string.h>
#include	<malloc.h>
#include	<ctype.h>
#include	"sym.h"
#include	"calc.h"

#define	CAL_TRUE	-1		/*	^	*/
#define	CAL_FALSE	0		/*	U	*/

#define	SZL	sizeof(long)

char	*Calc_yo[MAX_CALC];
char	Calc_data[256];
int		Calc_cnt;

extern	char	Sym[];

#ifdef	PROTOTYPE1
static char *code (int);
static int calc_sub1 (char *);
static void set_level (char *);
int calc (char *,int);
extern int sym_set(char *);
extern int sym_get(void);
#else
static char *code ();
static int calc_sub1 ();
static void set_level ();
int calc ();
extern int sym_set();
extern int sym_get();
#endif

#ifdef	PROTOTYPE1
static char	*code( int n )
#else
static char	*code( n )
int		n;
#endif
{
	switch( n ) {
		case	CAL_LPAR:	/*	(	*/
			return( "(" );
		case	CAL_RPAR:	/*	)	*/
			return( ")" );
		case	CAL_DIV:	/*	/	*/
			return( "/" );
		case	CAL_MUL:	/*	*	*/
			return( "*" );
		case	CAL_MOD:	/*	%	*/
			return( "%" );
		case	CAL_SUB:	/*	-	*/
			return( "-" );
		case	CAL_ADD:	/*	+	*/
			return( "+" );
		case	CAL_LSHIFT:	/*	<<	*/
			return( "<<" );
		case	CAL_RSHIFT:	/*	>>	*/
			return( ">>" );
		case	CAL_EQL:	/*	==	*/
			return( "==" );
		case	CAL_LSS:	/*	<	*/
			return( "<" );
		case	CAL_GTR:	/*	>	*/
			return( ">" );
		case	CAL_NEQ:	/*	<>,!=	*/
			return( "!=" );
		case	CAL_LEQ:	/*	<=	*/
			return( "<=" );
		case	CAL_GEQ:	/*	>=	*/
			return( ">=" );
		case	CAL_BOR:	/*	|	*/
			return( "|" );
		case	CAL_BAND:	/*	&	*/
			return( "&" );
		case	CAL_BXOR:	/*	^	*/
			return( "^" );
		case	CAL_BREV:	/*	~	*/
			return( "~" );
		case	CAL_NOT:	/*	!	*/
			return( "!" );
		case	CAL_OR:		/*	||	*/
			return( "||" );
		case	CAL_AND:	/*	&&	*/
			return( "&&" );
		case	CAL_STR:
			return( "STR" );
		case	CAL_NUM:
			return( "NUM" );
		case	CAL_OTHER:
			return( "OTHER" );
		case	CAL_LOW:
			return( "low" );
		case	CAL_HIGH:
			return( "high" );
		case	CAL_BIT_MAX:
			return( "bit_max" );
		default:
			return( "null" );
	}
}

#ifdef	PROTOTYPE1
static	int		calc_sub1( char *bf )
#else
static	int		calc_sub1( bf )
char	*bf;
#endif
{
	int		rc, cnt, adr, sym, flg;
	int		old_op;			/*	ỎZq	*/
	long	num;

	/*	sym_get() gpčڂ𕪉	*/
	if( sym_set( bf ) == -1 ) {
		return( -1 );
	}
	cnt = 0;
	adr = 0;
	old_op = 0;
	Calc_yo[cnt] = (char *)&Calc_data[adr];
	while( 1 ) {
		rc = sym_get();
		if( rc == SYM_END ) {
			if( cnt == (MAX_CALC-1) ) {
				return( -1 );
			}
			if( old_op == CAL_MINUS ) {
				if( Calc_yo[cnt-1][0] == CAL_ADD ) {
					Calc_yo[cnt-1][0] = CAL_SUB;
				} else {
					Calc_yo[cnt][0] = CAL_SUB;
					cnt++;
					adr++;
					Calc_yo[cnt] = (char *)&Calc_data[adr];
				}
			}
			Calc_yo[cnt][0] = 0;
			return cnt;
		}
		if( cnt == MAX_CALC ) {
			return( -1 );
		}
		switch( rc ) {
			case	SYM_STR:
				/* 2000/04/28 low(),high() ̏ǉ */
				flg = 0;
				if( strcmp( Sym, "low" ) == 0 ) {
					flg = CAL_LOW;
				} else if( strcmp( Sym, "high" ) == 0 ) {
					flg = CAL_HIGH;
				/* 2000/10/28 bit_max() ̏ǉ */
				} else if( strcmp( Sym, "bit_max" ) == 0 ) {
					flg = CAL_BIT_MAX;
				}
#if 0
/*	Zq݂̂ƂăT|[gȂiO\ɂȂėpւ邽߁j	*/
/*	Kvɂ #if 1 ŃT|[g\	*/
				switch( *Sym ) {
					case	'm':
						if( strcmp( Sym, "mod" ) == 0 ) {
							flg = CAL_MOD;
						}
						break;
					case	's':
						if( strcmp( Sym, "shl" ) == 0 ) {
							flg = CAL_LSHIFT;
						} else if( strcmp( Sym, "shr" ) == 0 ) {
							flg = CAL_RSHIFT;
						}
						break;
					case	'l':
						if( strcmp( Sym, "lt" ) == 0 ) {
							flg = CAL_LSS;
						} else if( strcmp( Sym, "le" ) == 0 ) {
							flg = CAL_LEQ;
						}
						break;
					case	'g':
						if( strcmp( Sym, "gt" ) == 0 ) {
							flg = CAL_GTR;
						} else if( strcmp( Sym, "ge" ) == 0 ) {
							flg = CAL_GEQ;
						}
						break;
					case	'e':
						if( strcmp( Sym, "eq" ) == 0 ) {
							flg = CAL_EQL;
						}
						break;
					case	'n':
						if( strcmp( Sym, "ne" ) == 0 ) {
							flg = CAL_NEQ;
						} else if( strcmp( Sym, "not" ) == 0 ) {
							flg = CAL_NOT;
						}
						break;
					default:	break;
				}
#endif
				if( flg ) {
					Calc_yo[cnt][0] = flg;
					cnt++;
					adr++;
					Calc_yo[cnt] = (char *)&Calc_data[adr];
					break;
				}
				if( old_op == CAL_MINUS ) {
					/*	Õf[^ + ɂĂ - ɖ߂	*/
					if( Calc_yo[cnt-1][0] == CAL_ADD ) {
						Calc_yo[cnt-1][0] = CAL_SUB;
					} else {
						Calc_yo[cnt][0] = CAL_SUB;
						cnt++;
						adr++;
						Calc_yo[cnt] = (char *)&Calc_data[adr];
					}
				}
				Calc_yo[cnt][0] = CAL_STR;
				strcpy( &Calc_yo[cnt][1], Sym );
				adr += (strlen(Sym)+2);
				cnt++;
				Calc_yo[cnt] = (char *)&Calc_data[adr];
				old_op = 0;
				break;
			case	SYM_VAL:
				Calc_yo[cnt][0] = CAL_NUM;
				sscanf( Sym, "%ld", &num );
				if( old_op == CAL_MINUS ) {
					num = -num;
				}
				memcpy( &Calc_yo[cnt][1], (char *)&num, SZL );
				cnt++;
				adr += (SZL+1);
				Calc_yo[cnt] = (char *)&Calc_data[adr];
				old_op = SYM_VAL;
				break;
			case	SYM_LINEEND:
				break;
			default:
				sym = 0;
				if( Sym[1] == 0x00 ) {
					switch( Sym[0] ) {
						case	'(':	sym = CAL_LPAR;	break;
						case	')':	sym = CAL_RPAR;	break;
						case	'/':	sym = CAL_DIV;	break;
						case	'*':	sym = CAL_MUL;	break;
						case	'%':	sym = CAL_MOD;	break;
						case	'-':	sym = CAL_SUB;	break;
						case	'+':	sym = CAL_ADD;	break;
						case	'<':	sym = CAL_LSS;	break;
						case	'>':	sym = CAL_GTR;	break;
						case	'|':	sym = CAL_BOR;	break;
						case	'&':	sym = CAL_BAND;	break;
						case	'^':	sym = CAL_BXOR;	break;
						case	'~':	sym = CAL_BREV;	break;
						case	'!':	sym = CAL_NOT;	break;
						default:	break;
					}
				} else if( Sym[2] == 0x00 ) {
					if( strcmp( Sym, "<<" ) == 0 ) {
						sym = CAL_LSHIFT;
					} else if( strcmp( Sym, ">>" ) == 0 ) {
						sym = CAL_RSHIFT;
					} else if( strcmp( Sym, "==" ) == 0 ) {
						sym = CAL_EQL;
					} else if( strcmp( Sym, "<>" ) == 0 ) {
						sym = CAL_NEQ;
					} else if( strcmp( Sym, "!=" ) == 0 ) {
						sym = CAL_NEQ;
					} else if( strcmp( Sym, "<=" ) == 0 ) {
						sym = CAL_LEQ;
					} else if( strcmp( Sym, ">=" ) == 0 ) {
						sym = CAL_GEQ;
					} else if( strcmp( Sym, "||" ) == 0 ) {
						sym = CAL_OR;
					} else if( strcmp( Sym, "&&" ) == 0 ) {
						sym = CAL_AND;
					}
				}
				if( sym == 0 ) {
					if( old_op == CAL_MINUS ) {
						/*	Õf[^ + ɂĂ - ɖ߂	*/
						if( Calc_yo[cnt-1][0] == CAL_ADD ) {
							Calc_yo[cnt-1][0] = CAL_SUB;
						} else {
							Calc_yo[cnt][0] = CAL_SUB;
							cnt++;
							adr++;
							Calc_yo[cnt] = (char *)&Calc_data[adr];
						}
					}
					Calc_yo[cnt][0] = CAL_OTHER;
					strcpy( &Calc_yo[cnt][1], Sym );
					adr += (strlen(Sym)+2);
					cnt++;
					Calc_yo[cnt] = (char *)&Calc_data[adr];
					old_op = 0;
					break;
				}
				if( old_op == CAL_MINUS ) {
					/*	Õf[^ + ɂĂ - ɖ߂	*/
					if( Calc_yo[cnt-1][0] == CAL_ADD ) {
						Calc_yo[cnt-1][0] = CAL_SUB;
					} else {
						Calc_yo[cnt][0] = CAL_SUB;
						cnt++;
						adr++;
						Calc_yo[cnt] = (char *)&Calc_data[adr];
					}
				}
				if( sym == CAL_SUB ) {
					/* 10/13 C */
					if( old_op != SYM_VAL ) {
						/*	- ͎̐lɕt	*/
						old_op = CAL_MINUS;
						break;
					}
					sym = CAL_ADD;
					/*	- ͎̐lɕt	*/
					old_op = CAL_MINUS;
				} else {
					old_op = sym;		/*	ŏIZqL	*/
				}
				Calc_yo[cnt][0] = sym;
				cnt++;
				adr++;
				Calc_yo[cnt] = (char *)&Calc_data[adr];
				break;
		}
	}
}

#ifdef	PROTOTYPE1
static	void	set_level( char *cal_level )			/*	Zq̗D揇ʊi[	*/
#else
static	void	set_level( cal_level )			/*	Zq̗D揇ʊi[	*/
char	*cal_level;
#endif
{
	cal_level[CAL_LPAR]   = 0;	/*	(	*/
	cal_level[CAL_RPAR]   = 0;	/*	)	*/
	cal_level[CAL_DIV]    = 6;	/*	/	*/
	cal_level[CAL_MUL]    = 6;	/*	*	*/
	cal_level[CAL_MOD]    = 6;	/*	%	*/
	cal_level[CAL_SUB]    = 5;	/*	-	*/
	cal_level[CAL_ADD]    = 5;	/*	+	*/
	cal_level[CAL_LSHIFT] = 4;	/*	<<	*/
	cal_level[CAL_RSHIFT] = 4;	/*	>>	*/
	cal_level[CAL_EQL]    = 3;	/*	==	*/
	cal_level[CAL_LSS]    = 3;	/*	<	*/
	cal_level[CAL_GTR]    = 3;	/*	>	*/
	cal_level[CAL_NEQ]    = 3;	/*	<>,!=	*/
	cal_level[CAL_LEQ]    = 3;	/*	<=	*/
	cal_level[CAL_GEQ]    = 3;	/*	>=	*/
	cal_level[CAL_BOR]    = 2;	/*	|	*/
	cal_level[CAL_BAND]   = 2;	/*	&	*/
	cal_level[CAL_BXOR]   = 2;	/*	^	*/
	cal_level[CAL_BREV]   = 7;	/*	~	  2000/05/19 2 -> 7 */
	cal_level[CAL_NOT]    = 7;	/*	!	  2000/05/19 2 -> 7 */
	cal_level[CAL_OR]     = 1;	/*	||	*/
	cal_level[CAL_AND]    = 1;	/*	&&	*/
	cal_level[CAL_LOW]    = 0;	/*	low(stringƓ)	*/
	cal_level[CAL_HIGH]   = 0;	/*	high(stringƓ)	*/
	cal_level[CAL_BIT_MAX]= 0;	/*	bit_max(stringƓ)	*/
	cal_level[CAL_STR]    = 0;	/*	string	*/
	cal_level[CAL_NUM]    = 0;	/*	number	*/
	cal_level[CAL_OTHER]  = 0;	/*	̑	*/
}

/*	Z̗D揇						*/
/*	8 : (,)								*/
/*	7 : !,~								 2000/05/19 2 -> 7 */
/*	6 : /,*,%						||	*/
/*	5 : -,+							||	*/
/*	4 : <<,>>						||	*/
/*	3 : ==,<,>,<>,<=,=<,>=,=>,!=	||	*/
/*	2 : |,&,^							*/
/*	1 : ||,&&							*/

/* ^[l -1:ُA0:Ȃǂ܂ŌvZA1:vZʂPɂȂ */
#ifdef	PROTOTYPE1
int		calc( char *bf, int sw )
#else
int		calc( bf, sw )
char	*bf;
int		sw;
#endif
/* sw 0:ʏA1:(123+456*(1+2))Ȃǂ̊OʂD揇ʎwł͂Ȃ̂Ŏc */
/*    2:ʏAvf̊On */
{
	char	tmp[20];
	char	lv[10];						/*	x[vp		*/
	int		yo_n, old_yo_n, m, n, wrt_ptr;
	int		level, num_flg, nchk_flg;
	int		st, en;						/*	ʈʒuLp		*/
	char	sv_str[256];				/*	ۑp		*/
	char	*sv_ptr[MAX_CALC];			/*	ۑp		*/
	int		sv_cnt, sv_adr;
	int		low_high_flg;
	long	num1, num2, num;
	long	*tmp_ptr;
	static	char	cal_level[0x40];	/*	D揇ʊi[p		*/
	static	char	init_flg = 1;

	if( sw == 2 ) {
		sw = 0;
		yo_n = Calc_cnt;
	} else {
		yo_n = calc_sub1( bf );			/*	evfւ̓WJ	*/
	}
	if( yo_n < 1 ) {
		return( -1 );
	}
	if( init_flg ) {
		set_level( cal_level );		/*	Zq̗D揇ʊi[	*/
		init_flg = 0;
	}
	old_yo_n = 0;
	sv_cnt = sv_adr = 0;
	for( ;; ) {
		st = en = -1;
		memset( lv, 0x00, sizeof( lv ) );
		for( n=(yo_n-1); n>=0; n-- ) {
			lv[ cal_level[ Calc_yo[n][0] ] ] = 1;
			if( Calc_yo[n][0] == CAL_LPAR ) {
				st = n;
				break;
			} else if( Calc_yo[n][0] == CAL_RPAR ) {
				en = n;
			}
		}
		if( st > en ) {
			return -1;
		}
		if( st == -1 || en == -1 ) {
			st = 0;
			en = yo_n-1;
		}
#ifdef	DEBUG
	for( n=st; n<=en; n++) {
		if( Calc_yo[n][0] == CAL_NUM ) {
			printf("%d[%s]:%ld   ", n, code(Calc_yo[n][0]), *(long *)&Calc_yo[n][1] );
		} else if( Calc_yo[n][0] == CAL_STR ) {
			printf("%d[%s]:%s   ", n, code(Calc_yo[n][0]), &Calc_yo[n][1] );
		} else {
			printf("%d[%s]   ", n, code(Calc_yo[n][0]) );
		}
	}
	printf("\n");
#endif
		/*	ωȂmF	*/
		if( old_yo_n == yo_n ) {
			/*	st  en ܂łۑ	*/
			sv_ptr[sv_cnt] = &sv_str[sv_adr];
			sv_ptr[sv_cnt][0] = CAL_STR;
			sv_ptr[sv_cnt][1] = 0x00;
			for( n=st; n<=en; n++) {
				switch( Calc_yo[n][0] ) {
					case	CAL_STR:
						if( n>=st && n>0 &&
								(Calc_yo[n-1][0]==CAL_STR || Calc_yo[n-1][0]==CAL_NUM) ){
							strcat( sv_ptr[sv_cnt], " " );
						}
						strcat( sv_ptr[sv_cnt], &Calc_yo[n][1] );
						break;
					case	CAL_NUM:
						memcpy( (char *)&num, &Calc_yo[n][1], SZL );
						if( n>=st && n>0 &&
								(Calc_yo[n-1][0]==CAL_STR || Calc_yo[n-1][0]==CAL_NUM) ){
							sprintf( tmp, " %ld", num );
						} else {
							sprintf( tmp, "%ld", num );
						}
						/*	db -1 ̂߂ɒǉ	*/
						if( sv_ptr[sv_cnt][strlen(sv_ptr[sv_cnt])-1] == '+' &&
								*tmp == '-' ) {
							sv_ptr[sv_cnt][strlen(sv_ptr[sv_cnt])-1] = 0x00;
						}
						strcat( sv_ptr[sv_cnt], tmp );
						break;
					case	CAL_OTHER:
						strcat( sv_ptr[sv_cnt], &Calc_yo[n][1] );
						break;
					default:
						strcat( sv_ptr[sv_cnt], code( Calc_yo[n][0] ) );
						break;
				}
			}
			sv_adr += (strlen( sv_ptr[sv_cnt] ) + 1 );
			Calc_yo[st] = sv_ptr[sv_cnt];
			sv_cnt++;
			for( m=st+1; m<(yo_n-(en-st)); m++ ) {
				Calc_yo[m] = Calc_yo[m+(en-st)];
			}
			yo_n -= (en-st);
			continue;
		}
		/*	ڂPɂȂωȂmF	*/
		if( st == en || old_yo_n == yo_n ) {
			/*	printf("**check point 1**\n");	*/
			bf[0] = 0x00;
			m = 0;
			for( n=0; n<yo_n; n++ ) {
				switch( Calc_yo[n][0] ) {
					case	CAL_STR:
						m++;
						/*	printf("CAL_STR[%s]\n",&Calc_yo[n][1]);	*/
						if( n>=st && n>0 &&
								(Calc_yo[n-1][0]==CAL_STR ||
								 Calc_yo[n-1][0]==CAL_NUM) ){
							strcat( bf, " " );
						}
						strcat( bf, &Calc_yo[n][1] );
						break;
					case	CAL_NUM:
						m++;
						memcpy( (char *)&num, &Calc_yo[n][1], SZL );
						if( n>=st && n>0 &&
								(Calc_yo[n-1][0]==CAL_STR ||
								 Calc_yo[n-1][0]==CAL_NUM) ){
							sprintf( tmp, " %ld", num );
						} else {
							sprintf( tmp, "%ld", num );
							if( n>=st && n>0 && strlen( bf ) ) {
								if( bf[strlen(bf)-1] == '+' && num < 0 ) {
									strcat( &bf[strlen(bf)-1], tmp );
									break;
								}
							}
						}
						/*	printf( "CAL_NUM[%s]\n", tmp );	*/
						strcat( bf, tmp );
						break;
					default:
						m++;
						/*	printf("CODE   [%s]\n",code(Calc_yo[n][0]));	*/
						strcat( bf, code(Calc_yo[n][0]) );
						break;
				}
			}
			if( m == 1 ) {
				if( Calc_yo[0][0] == CAL_NUM ) {
					return( 1 );
				} else if( *bf == '-' && isdigit( *(bf+1) ) ) {
					return( 1 );
				}
			}
			return( 0 );
		}
		level = 7;	/* 2000/05/19 6 -> 7 */
		lv[level] = 1;
		old_yo_n = yo_n;

		low_high_flg = 1;	/* tO low(),high(),bit_max() gĂ鎖ɂ */
		for( ;; ) {
			if( lv[level] == 0 ) {
				if( (--level) == 0 ) {
					break;
				}
				continue;
			}
			nchk_flg = 0;/*	vZoȐт̃tO	*/

			/* 2000/04/28 low(),high() ̏ǉ */
			/* 2000/10/28 bit_max() ̏ǉ */
			if( low_high_flg == 1 ) {
				/* low(),high(),bit_max() gĂ */
				/* SgĂȂ͎炱ɓȂ悤ɂ() */
				low_high_flg = 0;	/* gĂȂɏ */
				for( n=st; n<=en; n++ ) {
					/* low(), high(),bit_max() */
					if( Calc_yo[n][0] == CAL_LOW ) {
						low_high_flg = 1;	/* gĂ */
						if( Calc_yo[n+1][0] == CAL_NUM ) {
							memcpy( &num, &Calc_yo[n+1][1], SZL );
							num &= 0xff;
							memcpy(&Calc_yo[n][1],(char *)&num,SZL);
							Calc_yo[n][0] = CAL_NUM;
							for( m=n+1; m<(yo_n-1); m++ ) {
								Calc_yo[m] = Calc_yo[m+1];
							}
							en -= 1;
							yo_n -= 1;
						}
					} else if( Calc_yo[n][0] == CAL_HIGH ) {
						low_high_flg = 1;	/* gĂ */
						if( Calc_yo[n+1][0] == CAL_NUM ) {
							memcpy( &num, &Calc_yo[n+1][1], SZL );
							num = (num>>8)&0xff;
							memcpy(&Calc_yo[n][1],(char *)&num,SZL);
							Calc_yo[n][0] = CAL_NUM;
							for( m=n+1; m<(yo_n-1); m++ ) {
								Calc_yo[m] = Calc_yo[m+1];
							}
							en -= 1;
							yo_n -= 1;
						}
					} else if( Calc_yo[n][0] == CAL_BIT_MAX ) {
						low_high_flg = 1;	/* gĂ */
						if( Calc_yo[n+1][0] == CAL_NUM ) {
							memcpy( &num, &Calc_yo[n+1][1], SZL );
							if( num >= 32 ) {
								num = 0xffffffffL;
							} else {
								m = (int)num;
								num = 1;
								while( m ) {
									num <<= 1;
									m--;
								}
								num--;
							}
							memcpy(&Calc_yo[n][1],(char *)&num,SZL);
							Calc_yo[n][0] = CAL_NUM;
							for( m=n+1; m<(yo_n-1); m++ ) {
								Calc_yo[m] = Calc_yo[m+1];
							}
							en -= 1;
							yo_n -= 1;
						}
					}
				}
			}

			for( n=st+1; n<=en; n++ ) {
				if( Calc_yo[n-1][0] == CAL_NUM && Calc_yo[n+1][0] == CAL_NUM ) {
					nchk_flg = 1;
					memcpy( &num1, &Calc_yo[n-1][1], SZL );
					memcpy( &num2, &Calc_yo[n+1][1], SZL );
					/*	E̍ڂ̃xmF	*/
					if( (n-2) >= st ) {
						if( cal_level[ Calc_yo[n-2][0] ] > level &&
								Calc_yo[n-2][0] != CAL_LPAR ) {
							continue;
						}
					}
					if( (n+2) <= en ) {
						if( cal_level[ Calc_yo[n+2][0] ] > level &&
								Calc_yo[n+2][0] != CAL_RPAR ) {
							continue;
						}
					}
/* 2000/05/19	} else if( level == 2 && Calc_yo[n][0] == CAL_NUM && */
				} else if( level == cal_level[CAL_BREV] && Calc_yo[n][0] == CAL_NUM &&
						(Calc_yo[n-1][0] == CAL_BREV || Calc_yo[n-1][0] == CAL_NOT) ) {
					memcpy( &num, &Calc_yo[n][1], SZL );
					if( Calc_yo[n-1][0] == CAL_BREV ) {
						num = ~num;
					} else {
						num = !num;
					}
					memcpy( &Calc_yo[n][1], (char *)&num, SZL );
					Calc_yo[n-1] = Calc_yo[n];
					for( m=n; m<(yo_n-1); m++ ) {
						Calc_yo[m] = Calc_yo[m+1];
					}
					en -= 1;
					yo_n -= 1;
					n--;
					continue;
				} else {
					/*	̊ʂȂ肵AKvɂ폜	*/
					if( Calc_yo[n-1][0] == CAL_LPAR && Calc_yo[n+1][0] == CAL_RPAR &&
							Calc_yo[n][0] == CAL_NUM ) {
						/*	E̍ڂ̃xmF	*/
						if( sw == 1 ) {
							num_flg = 0;
							if( (n-2) >= 0 ) {
								if( Calc_yo[n-2][0] > CAL_DEF_ST &&
										Calc_yo[n-2][0] < CAL_DEF_EN ) {
									num_flg = 1;
								}
							}
							if( (n+2) <= (yo_n-1) ) {
								if( Calc_yo[n+2][0] > CAL_DEF_ST &&
										Calc_yo[n+2][0] < CAL_DEF_EN ) {
									num_flg = 1;
								}
							}
							if( num_flg == 0 ) {
								continue;
							}
						}
						Calc_yo[n-1] = Calc_yo[n];
						for( m=n; m<(yo_n-2); m++ ) {
							Calc_yo[m] = Calc_yo[m+2];
						}
						en -= 2;
						yo_n -= 2;
						n--;
					}
					continue;
				}
				num_flg = 1;
				switch( level ) {
					case	6:
						switch( Calc_yo[n][0] ) {
							case	CAL_DIV:	/*	/	*/
								num = num1 / num2;
								break;
							case	CAL_MUL:	/*	*	*/
								num = num1 * num2;
								break;
							case	CAL_MOD:	/*	%	*/
								num = num1 % num2;
								break;
							default:
								num_flg = 0;
								break;
						}
						break;
					case	5:
						switch( Calc_yo[n][0] ) {
							case	CAL_SUB:	/*	-	*/
								num = num1 - num2;
								break;
							case	CAL_ADD:	/*	+	*/
								num = num1 + num2;
								break;
							default:
								num_flg = 0;
								break;
						}
						break;
					case	4:
						switch( Calc_yo[n][0] ) {
							case	CAL_LSHIFT:	/*	<<	*/
								num = (num1 << num2);
								break;
							case	CAL_RSHIFT:	/*	>>	*/
								num = (num1 >> num2);
								break;
							default:
								num_flg = 0;
								break;
						}
						break;
					case	3:
						switch( Calc_yo[n][0] ) {
							case	CAL_EQL:	/*	==	*/
								if( num1 == num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							case	CAL_LSS:	/*	<	*/
								if( num1 < num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							case	CAL_GTR:	/*	>	*/
								if( num1 > num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							case	CAL_NEQ:	/*	<>,!=	*/
								if( num1 != num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							case	CAL_LEQ:	/*	<=	*/
								if( num1 <= num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							case	CAL_GEQ:	/*	>=	*/
								if( num1 >= num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							default:
								num_flg = 0;
								break;
						}
						break;
					case	2:
						switch( Calc_yo[n][0] ) {
							case	CAL_BOR:	/*	|	*/
								num = (num1 | num2);
								break;
							case	CAL_BAND:	/*	&	*/
								num = (num1 & num2);
								break;
							case	CAL_BXOR:	/*	^	*/
								num = (num1 ^ num2);
								break;
							default:
								num_flg = 0;
								break;
						}
						break;
					case	1:
						switch( Calc_yo[n][0] ) {
							case	CAL_OR:		/*	||	*/
								if( num1 || num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							case	CAL_AND:	/*	&&	*/
								if( num1 && num2 ) {
									num = CAL_TRUE;		/*	^	*/
								} else {
									num = CAL_FALSE;	/*	U	*/
								}
								break;
							default:
								num_flg = 0;
								break;
						}
						break;
					default:
						num_flg = 0;
						break;
				}
				if( num_flg ) {
					memcpy(&Calc_yo[n-1][1],(char *)&num,SZL);
					for( m=n; m<(yo_n-2); m++ ) {
						Calc_yo[m] = Calc_yo[m+2];
					}
					en -= 2;
					yo_n -= 2;
					n--;
					continue;
				}
			}
			if( (--level) == 0 || nchk_flg == 0 ) {
				break;
			}
		}
	}
}

#ifdef	DEBUG_MAIN
/***************************************/
/* bcc -DDEBUG_MAIN -N -v calc.c sym.c */
/***************************************/
int		main( ar, av )
int		ar;
char	*av[];
{
	char	bf[256];
	static	char	*md[] = {"()DEL  MODE","()SAVE MODE" };
	int		mode, rc;

	if( ar == 2 ) {
		mode = 1;
		strcpy( bf, av[1] );
		printf( "Org.            [%s]\n", bf );
		rc = calc( bf, mode );
		printf( "Ans.%s [%s]\nrc = %d\n", md[mode], bf, rc );
		mode = 0;
		strcpy( bf, av[1] );
		rc = calc( bf, mode );
		printf( "Ans.%s [%s]\nrc = %d\n", md[mode], bf, rc );
	} else {
		mode = 1;
		strcpy( bf, "a = low(10+5*2), b=high(256+5), c=bit_max(8)" );
		printf( "Org.            [%s]\n", bf );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
		mode = 0;
		strcpy( bf, "a = low(10+5*2), b=high(256+5), c=bit_max(8)" );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );

		mode = 1;
		strcpy( bf, "(IX+25+95*(12+8-5))" );
		printf( "Org.            [%s]\n", bf );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
		mode = 0;
		strcpy( bf, "(IX+25+95*(12+8-5))" );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );

		mode = 1;
		strcpy( bf, "12+13*(1+2)+15*(AX/2-5+8*(9-5))" );
		printf( "Org.            [%s]\n", bf );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
		mode = 0;
		strcpy( bf, "12+13*(1+2)+15*(AX/2-5+8*(9-5))" );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );

		mode = 1;
		strcpy( bf, "LD (IX+1+2),(1)*2,(HL)" );
		printf( "Org.            [%s]\n", bf );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
		mode = 0;
		strcpy( bf, "LD (IX+1+2),(1)*2,(HL)" );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );

		mode = 1;
		strcpy( bf, "LD A,(5),(5+1),(IX+2+2),!5,5 ^ 3,1 + !3,!0" );
		printf( "Org.            [%s]\n", bf );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
		mode = 0;
		strcpy( bf, "LD A,(5),(5+1),(IX+2+2),!5,5 ^ 3,1 + !3,!0" );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );

		mode = 1;
		strcpy( bf, "-5 <= -3" );
		printf( "Org.            [%s]\n", bf );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
		mode = 0;
		strcpy( bf, "-5 <= -3" );
		calc( bf, mode );
		printf( "Ans.%s [%s]\n", md[mode], bf );
	}
	return 0;
}
#endif
