/********************************************************/
/********************************************************/
/* V3.60 gpTu[`荞܂Ȃ@\ǉ */

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	<malloc.h>

#define	KEY_MAX				3000		/*	őL[ڐ	*/
#define	DATA_SEARCH			0
#define	DATA_LENGTH			1
#define	DATA_LENGTH_MASM	2
#define	DATA_ADDRESS		3
#define	TEMP_MAX			40

#define	ID_CONST		'0'			/*	萔		*/
#define	ID_CONST_NAME	'1'			/*	萔̖O	*/
#define	ID_MACRO		'2'			/*	}N		*/
#define	ID_VAR			'3'			/*	ϐ		*/
#define	ID_REGWORD		'4'			/*	\		*/
#define	ID_DEF			'5'			/*	u(2000/04/24) */
#define	CONST_ORG		100			/*	255ȓA`ȏ̐l	*/

typedef	struct	{
	char	*name;							/*	L[ږ	*/
	union	_p {
		char	*dt;						/*	萔		*/
		unsigned	long	adr;			/*	AhX	*/
	}	p;
	char	ext;							/*	gf[^	*/
	char	ref;					/*	V3.60 xƉꂽtO	*/
}	CONST_TBL;

static	CONST_TBL	bsrh_key[KEY_MAX];		/*	L[ڊi[GA			*/
static	int		key_cnt = 0;				/*	L[񍀖ڐ				*/
static	char	init_flg = 1;				/*						*/
static	char	Temp_key[80];
static	char	_Ext;						/*	x̃ZOg			*/
static	char	_Ref;						/*	V3.60 QƗLtOpp	*/
static	char	_RefSet = 0;				/*	V3.60 QƗLtOݒp	*/

#ifdef	PROTOTYPE1
void bsrh_init(int *,long *);
static int srh_sub(char *,char *,int);
int const_set(char *,char *,unsigned char);
int const_srh(char *,char *);
int def_set(char *,char *);
int def_srh(char *,char *);
int const_dt_len (char *);
int macro_set(char *,char *);
int macro_srh(char *,char *);
int macro_dt_len(char *);
int masm_dt_len(char *);
static int data_set(char *,unsigned long,char);
int val_set(char *,unsigned long);
int regword_set(char *);
int const_name_set(char *);
static int data_update(char *,unsigned long);
int val_update(char *,unsigned long);
int label_update(char *,unsigned long,char);
int label_srh(char *,unsigned long *,char *);
char label_srh_ref(char *);
int val_srh(char *,unsigned long *);
int regword_srh(char *);
int const_name_srh(char *);
#else
void bsrh_init();
static int srh_sub();
int const_set();
int const_srh();
int const_dt_len();
int def_set();
int def_srh();
int macro_set();
int macro_srh();
int macro_dt_len();
int masm_dt_len();
static int data_set();
int val_set();
int regword_set();
int const_name_set();
static int data_update();
int val_update();
int label_update();
int label_srh();
char label_srh_ref();
int val_srh();
int regword_srh();
int const_name_srh();
#endif

/*	i[GȀ	*/
#ifdef	PROTOTYPE1
void	bsrh_init( int *rc, long *mem )
#else
void	bsrh_init( rc, mem )
int		*rc;
long	*mem;
#endif
{
	int		n;
	long	mem_size;

	if( rc != NULL ) {
		*rc = key_cnt;
	}
	mem_size = 0L;
	for( n=0; n<key_cnt; n++ ) {
		if( bsrh_key[n].name != NULL ) {
			mem_size += sizeof( bsrh_key[n].name );
			switch( bsrh_key[n].name[strlen(bsrh_key[n].name)-1] ) {
				case	ID_CONST_NAME:	/*	萔̖O	*/
				case	ID_VAR:			/*	ϐ		*/
				case	ID_REGWORD:		/*	\		*/
					/* union GA adr Ŏg malloc ĂȂ */
					break;
				default:
					mem_size += sizeof( bsrh_key[n].p.dt );
					free( bsrh_key[n].p.dt );
					break;
			}
			free( bsrh_key[n].name );
		}
		bsrh_key[n].ext = 0;
		bsrh_key[n].ref = 0;
		bsrh_key[n].p.dt = NULL;
	}
	if( mem != NULL ) {
		*mem = mem_size;
	}
	key_cnt = 0;
	init_flg = 0;							/*						*/
}

/*	f[^̌֐	*/
#ifdef	PROTOTYPE1
static	int	srh_sub( char *key, char *bf, int sw )
#else
static	int	srh_sub( key, bf, sw )
char	*key;							/*	f[^					*/
char	*bf;							/*	ʃf[^				*/
int		sw;						/* DATA_SEARCH,DATA_LENGTH,DATA_ADDRESS */
#endif
{
	int		i, j, k, cmp;

	j = 0;
	k = key_cnt+1;
	for( ;; ) {
		if( k == (j+1) ) {
			if( sw == DATA_ADDRESS ) {	/*	i[ʒǔȂ	*/
				return( j );
			}
			return( -1 );				/*	f[^	*/
		}
		i = (j+k)/2;
		cmp = strcmp( bsrh_key[i-1].name, key );
		if( cmp == 0 ) {
			switch( sw ) {
			case	DATA_ADDRESS:	/*	i[ʒǔȂ	*/
				return( i-1 );
			case	DATA_LENGTH:
				return( strlen( bsrh_key[i-1].p.dt ) );
			case	DATA_LENGTH_MASM:
				/*	MASM ݊}NŗL΃f[^Ԃ	*/
				/*	MASM ݊}N STX ŊJn	*/
				if( bsrh_key[i-1].p.dt[0] == 0x02 ) {
					return( strlen( bsrh_key[i-1].p.dt ) );
				}
				return( 0 );
			default:
				if( bf != NULL ) {
					switch( key[strlen(key)-1] ) {
						case	ID_VAR:			/*	ϐ		*/
							bsrh_key[i-1].ref |= _RefSet;	/* QƂꂽǂݒ肷 */
							/* V3.60 ̂܂܉Ɍp */
						case	ID_CONST_NAME:	/*	萔̖O	*/
						case	ID_REGWORD:		/*	\		*/
							*(unsigned long *)bf = bsrh_key[i-1].p.adr;
							_Ext = bsrh_key[i-1].ext;
							_Ref = bsrh_key[i-1].ref;	/* V3.60 */
							break;
						default:
							strcpy( bf, bsrh_key[i-1].p.dt );
							break;
					}
				}
				return( 0 );
			}
		} else if( cmp < 0 ) {
			j = i;
		} else if( cmp > 0 ) {
			k = i;
		}
	}
}

/************************************************************************/
/*	constf[^̊i[													*/
/*	key:L[ږ  dat:L[ڑΉf[^  num:L[ږ̔ԍ		*/
/************************************************************************/
#ifdef	PROTOTYPE1
int		const_set( char *key, char *dat, unsigned char num )
#else
int		const_set( key, dat, num )
char	*key, *dat;
unsigned	char	num;
#endif
{
	int		len;
	int		set_adr, n, flg;
	char	bf[TEMP_MAX], *p;

	if( init_flg )	bsrh_init( NULL, NULL );
	if( key_cnt >= KEY_MAX ) {
		fprintf( stderr, "key table overflow (max:%d)!!!\n", KEY_MAX );
		return(-1);
	}
	sprintf( Temp_key, "%s%c", key, ID_CONST );
	/*	f[^̗LmF	*/
	flg = 0;
	if( srh_sub( Temp_key, NULL, DATA_SEARCH ) == 0 ) {
		flg = 1;
	}
	set_adr = srh_sub( Temp_key, NULL, DATA_ADDRESS );/*	i[ʒu擾	*/
	/*	+6:" "+num(ő3)+" "+NULL	*/
	if( (strlen(dat)+6) >= TEMP_MAX ) {
		fprintf( stderr, "const temp max error (max:%d)!!!\n", TEMP_MAX );
		return( -1 );
	}
	sprintf( bf, " %d %s", num, dat );
	if( flg == 0 ) {	/*	VKȂ	*/
		key_cnt++;
		for( n=key_cnt; n>set_adr; n-- ) {
			bsrh_key[n].name = bsrh_key[n-1].name;
			bsrh_key[n].p.dt = bsrh_key[n-1].p.dt;
			bsrh_key[n].ext = bsrh_key[n-1].ext;
		}
		bsrh_key[set_adr].name = (char *)malloc(strlen( Temp_key ) + 1);
		if( bsrh_key[set_adr].name == NULL ) {
			fprintf( stderr, "const malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].name, Temp_key );
		bsrh_key[set_adr].p.dt = (char *)malloc(strlen( bf )+strlen(key)+5);
		if( bsrh_key[set_adr].p.dt == NULL ) {
			fprintf( stderr, "const malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].p.dt, &bf[1] );
		sprintf( bf, " %d ", CONST_ORG );
		strcat( bsrh_key[set_adr].p.dt, bf );
		strcat( bsrh_key[set_adr].p.dt, key );
	} else {		/*	ǉȂ	*/
		p = bsrh_key[set_adr].p.dt;
		bsrh_key[set_adr].p.dt = (char *)malloc(strlen(p) + strlen( bf ) + 1);
		if( bsrh_key[set_adr].p.dt == NULL ) {
			fprintf( stderr, "const malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].p.dt, p );
		free( p );
		strcat( bsrh_key[set_adr].p.dt, bf );
	}
	return( 0 );
}

/*	CONST ̌	*/
#ifdef	PROTOTYPE1
int		const_srh( char *key, char *dt )
#else
int		const_srh( key, dt )
char	*key, *dt;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_CONST );
	return( srh_sub( Temp_key, dt, DATA_SEARCH ) );
}

/*	CONST f[^̎擾	*/
#ifdef	PROTOTYPE1
int		const_dt_len( char *key )
#else
int		const_dt_len( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_CONST );
	return( srh_sub( Temp_key, NULL, DATA_LENGTH ) );
}

/************************************************************************/
/*	deff[^̊i[														*/
/*	key:L[ږ  dat:L[ڑΉf[^								*/
/************************************************************************/
#ifdef	PROTOTYPE1
int		def_set( char *key, char *dat )
#else
int		def_set( key, dat )
char	*key, *dat;
#endif
{
	int		set_adr, n, flg;

	if( init_flg )	bsrh_init( NULL, NULL );
	if( key_cnt >= KEY_MAX ) {
		fprintf( stderr, "key table overflow (max:%d)!!!\n", KEY_MAX );
		return(-1);
	}
	sprintf( Temp_key, "%s%c", key, ID_DEF );
	/*	f[^̗LmF	*/
	flg = 0;
	if( srh_sub( Temp_key, NULL, DATA_SEARCH ) == 0 ) {
		flg = 1;
	}
	set_adr = srh_sub( Temp_key, NULL, DATA_ADDRESS );/*	i[ʒu擾	*/
	/*	+6:" "+num(ő3)+" "+NULL	*/
	if( (strlen(dat)+6) >= TEMP_MAX ) {
		fprintf( stderr, "def temp max error (max:%d)!!!\n", TEMP_MAX );
		return( -1 );
	}
	if( flg == 0 ) {	/*	VKȂ	*/
		key_cnt++;
		for( n=key_cnt; n>set_adr; n-- ) {
			bsrh_key[n].name = bsrh_key[n-1].name;
			bsrh_key[n].p.dt = bsrh_key[n-1].p.dt;
			bsrh_key[n].ext = bsrh_key[n-1].ext;
		}
		bsrh_key[set_adr].name = (char *)malloc(strlen( Temp_key ) + 1);
		if( bsrh_key[set_adr].name == NULL ) {
			fprintf( stderr, "def malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].name, Temp_key );
		bsrh_key[set_adr].p.dt = (char *)malloc(strlen( dat ) + 1);
		if( bsrh_key[set_adr].p.dt == NULL ) {
			fprintf( stderr, "def malloc error!!!\n" );
			return( -1 );
		}
	} else {		/*	XVȂ	*/
		free( bsrh_key[set_adr].p.dt );
		bsrh_key[set_adr].p.dt = (char *)malloc(strlen( dat ) + 1);
		if( bsrh_key[set_adr].p.dt == NULL ) {
			fprintf( stderr, "def malloc error!!!\n" );
			return( -1 );
		}
	}
	strcpy( bsrh_key[set_adr].p.dt, dat );
	return( 0 );
}

/*	def ̌	*/
#ifdef	PROTOTYPE1
int		def_srh( char *key, char *dt )
#else
int		def_srh( key, dt )
char	*key, *dt;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_DEF );
	return( srh_sub( Temp_key, dt, DATA_SEARCH ) );
}

/************************************************/
/*	}Nf[^̊i[							*/
/*	key:L[ږ  dat:L[ڑΉf[^		*/
/************************************************/
#ifdef	PROTOTYPE1
int		macro_set( char *key, char *dat )
#else
int		macro_set( key, dat )
char	*key, *dat;
#endif
{
	int		len;
	int		set_adr, n, flg;
	char	*p;

	if( init_flg )	bsrh_init( NULL, NULL );
	if( key_cnt >= KEY_MAX ) {
		fprintf( stderr, "key table overflow (max:%d)!!!\n", KEY_MAX );
		return(-1);
	}
	sprintf( Temp_key, "%s%c", key, ID_MACRO );
	/*	f[^̗LmF	*/
	flg = 0;
	if( srh_sub( Temp_key, NULL, DATA_SEARCH ) == 0 ) {
		flg = 1;
	}
	set_adr = srh_sub( Temp_key, NULL, DATA_ADDRESS );/*	i[ʒu擾	*/
	if( flg == 0 ) {	/*	VKȂ	*/
		key_cnt++;
		for( n=key_cnt; n>set_adr; n-- ) {
			bsrh_key[n].name = bsrh_key[n-1].name;
			bsrh_key[n].p.dt = bsrh_key[n-1].p.dt;
			bsrh_key[n].ext = bsrh_key[n-1].ext;
		}
		bsrh_key[set_adr].name = (char *)malloc(strlen( Temp_key ) + 1);
		if( bsrh_key[set_adr].name == NULL ) {
			fprintf( stderr, "macro malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].name, Temp_key );
		bsrh_key[set_adr].p.dt = (char *)malloc(strlen( dat ) + 1);
		if( bsrh_key[set_adr].p.dt == NULL ) {
			fprintf( stderr, "macro malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].p.dt, dat );
	} else {		/*	ǉȂ	*/
		p = bsrh_key[set_adr].p.dt;
		bsrh_key[set_adr].p.dt = (char *)malloc(strlen(p) + strlen( dat ) + 1);
		if( bsrh_key[set_adr].p.dt == NULL ) {
			fprintf( stderr, "macro malloc error!!!\n" );
			return( -1 );
		}
		strcpy( bsrh_key[set_adr].p.dt, p );
		free( p );
		strcat( bsrh_key[set_adr].p.dt, dat );
	}
	return( 0 );
}

/*	}Ň	*/
#ifdef	PROTOTYPE1
int		macro_srh( char *key, char *dt )
#else
int		macro_srh( key, dt )
char	*key, *dt;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_MACRO );
	return( srh_sub( Temp_key, dt, DATA_SEARCH ) );
}

/*	}Nf[^̎擾	*/
#ifdef	PROTOTYPE1
int		macro_dt_len( char *key )
#else
int		macro_dt_len( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_MACRO );
	return( srh_sub( Temp_key, NULL, DATA_LENGTH ) );
}

/*	MASM ݊}Nf[^̎擾	*/
#ifdef	PROTOTYPE1
int		masm_dt_len( char *key )
#else
int		masm_dt_len( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_MACRO );
	return( srh_sub( Temp_key, NULL, DATA_LENGTH_MASM ) );
}

/***********************************************************/
/*	f[^̊i[											*/
/*	key:L[ږ  dat:L[ڑΉf[^  ext:gf[^	*/
/***********************************************************/
#ifdef	PROTOTYPE1
static	int	data_set( char *key, unsigned long dat, char ext )
#else
static	int	data_set( key, dat, ext )
char	*key;
unsigned	long	dat;
char	ext;
#endif
{
	int		set_adr, n;
	char	*p;

	if( init_flg )	bsrh_init( NULL, NULL );
	if( key_cnt >= KEY_MAX ) {
		fprintf( stderr, "key table overflow (max:%d)!!!\n", KEY_MAX );
		return(-1);
	}
	/*	f[^̗LmF	*/
	if( srh_sub( Temp_key, NULL, DATA_SEARCH ) == 0 ) {
		fprintf( stderr, "Qd` [%s]\n", key );
		return(-1);
	}
	set_adr = srh_sub( Temp_key, NULL, DATA_ADDRESS );/*	i[ʒu擾	*/
	key_cnt++;
	for( n=key_cnt; n>set_adr; n-- ) {
		bsrh_key[n].name = bsrh_key[n-1].name;
		bsrh_key[n].p.dt = bsrh_key[n-1].p.dt;
		bsrh_key[n].ext = bsrh_key[n-1].ext;
	}
	bsrh_key[set_adr].name = (char *)malloc(strlen( Temp_key ) + 1);
	if( bsrh_key[set_adr].name == NULL ) {
		fprintf( stderr, "data_set malloc error!!!\n" );
		return( -1 );
	}
	strcpy( bsrh_key[set_adr].name, Temp_key );
	bsrh_key[set_adr].p.adr = dat;
	bsrh_key[set_adr].ext = ext;
	return( 0 );
}

/************************************************/
/*	ϐf[^̊i[							*/
/*	key:L[ږ  dat:L[ڑΉf[^		*/
/************************************************/
#ifdef	PROTOTYPE1
int		val_set( char *key, unsigned long dat )
#else
int		val_set( key, dat )
char	*key;
unsigned	long	dat;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_VAR );
	return( data_set( key, dat, 0 ) );
}

/************************************************/
/*	\̊i[								*/
/************************************************/
#ifdef	PROTOTYPE1
int		regword_set( char *key )
#else
int		regword_set( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_REGWORD );
	return( data_set( key, 0L, 0 ) );
}

/************************************************/
/*	萔̊i[								*/
/************************************************/
#ifdef	PROTOTYPE1
int		const_name_set( char *key )
#else
int		const_name_set( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_CONST_NAME );
	return( data_set( key, 0L, 0 ) );
}

/************************************************/
/*	f[^̍XV								*/
/*	key:L[ږ  dat:L[ڑΉf[^		*/
/************************************************/
#ifdef	PROTOTYPE1
static	int	data_update( char *key, unsigned long dat )
#else
static	int	data_update( key, dat )
char	*key;
unsigned	long	dat;
#endif
{
	int		set_adr;

	if( init_flg )	bsrh_init( NULL, NULL );
	/*	f[^̗LmF	*/
	if( srh_sub( Temp_key, NULL, DATA_SEARCH ) == -1 ) {
		/*	f[^o^ȂVKǉ	*/
		if( val_set( key, 0xffffffffL ) == -1 ) {
			return( -1 );
		}
	}
	set_adr = srh_sub( Temp_key, NULL, DATA_ADDRESS );/*	i[ʒu擾	*/
	bsrh_key[set_adr].p.adr = dat;
	/*	xf[^XVłgpȂ̂ŊȒPɃO[oϐgp	*/
	bsrh_key[set_adr].ext = _Ext;
	return( 0 );
}

/************************************************************/
/*	xf[^̍XV										*/
/*	key:L[ږ  dat:L[ڑΉf[^  ext:gf[^	*/
/************************************************************/
#ifdef	PROTOTYPE1
int		label_update( char *key, unsigned long dat, char ext )
#else
int		label_update( key, dat, ext )
char	*key;
unsigned	long	dat;
char	ext;
#endif
{
	int		rc;

	/* ID  VAR ƓAEXT i[\Ƃ */
	sprintf( Temp_key, "%s%c", key, ID_VAR );
	_Ext = ext;
	rc = data_update( key, dat );
	_Ext = 0;
	return( rc );
}

/************************************************/
/*	ϐf[^̍XV							*/
/*	key:L[ږ  dat:L[ڑΉf[^		*/
/************************************************/
#ifdef	PROTOTYPE1
int		val_update( char *key, unsigned long dat )
#else
int		val_update( key, dat )
char	*key;
unsigned	long	dat;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_VAR );
	return( data_update( key, dat ) );
}

/*	xϐ̌ val_srh Ɠ@\ + EXT ̎擾	*/
#ifdef	PROTOTYPE1
int		label_srh( char *key, unsigned long *dt, char *ext )
#else
int		label_srh( key, dt, ext )
char	*key;
unsigned	long	*dt;
char	*ext;
#endif
{
	int		rc;

	_RefSet = 1;	/*	V3.60 QƗLtOݒp	*/
	sprintf( Temp_key, "%s%c", key, ID_VAR );
	rc = srh_sub( Temp_key, (char *)dt, DATA_SEARCH );
	*ext = _Ext;
	_RefSet = 0;	/*	V3.60 QƗLtOݒp	*/
	return( rc );
}

/*	xϐ̌ REF ̎擾	*/
#ifdef	PROTOTYPE1
char	label_srh_ref( char *key )
#else
char	label_srh_ref( key )
char	*key;
#endif
{
	long	dt;

	sprintf( Temp_key, "%s%c", key, ID_VAR );
	if( srh_sub( Temp_key, (char *)&dt, DATA_SEARCH ) == 0 ) {
		return( _Ref );
	}
	return( 0 );
}

/*	ϐ̌	*/
#ifdef	PROTOTYPE1
int		val_srh( char *key, unsigned long *dt )
#else
int		val_srh( key, dt )
char	*key;
unsigned	long	*dt;
#endif
{
	int		rc;

	_RefSet = 1;	/*	V3.60 QƗLtOݒp	*/
	sprintf( Temp_key, "%s%c", key, ID_VAR );
	rc = srh_sub( Temp_key, (char *)dt, DATA_SEARCH );
	_RefSet = 0;	/*	V3.60 QƗLtOݒp	*/
	return( rc );
}

/*	\̌	*/
#ifdef	PROTOTYPE1
int		regword_srh( char *key )
#else
int		regword_srh( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_REGWORD );
	return( srh_sub( Temp_key, NULL, DATA_SEARCH ) );
}

/*	萔̌	*/
#ifdef	PROTOTYPE1
int		const_name_srh( char *key )
#else
int		const_name_srh( key )
char	*key;
#endif
{
	sprintf( Temp_key, "%s%c", key, ID_CONST_NAME );
	return( srh_sub( Temp_key, NULL, DATA_SEARCH ) );
}

#ifdef	DEBUG_MAIN
int	main()
{
	int		okng, len, n;
	char	*bf, *p;
	unsigned	long	adr;
	static	char	*macro[] = { "LD _SS", "LD _SS2", "ABC _SS2", "" };
	static	char	*const_[] = { "A", "BC", "DE", "AB", "" };

	printf( "<<< DATA SET >>>\n" );
	printf( "macro[%d]  ", macro_set( macro[0], " P1\n" ) );
	printf( "[%d]  ", macro_set( macro[0], " P2\n" ) );
	printf( "[%d]  ", macro_set( macro[0], " P3\n" ) );
	printf( "[%d]  ", macro_set( macro[1], " A9\n" ) );
	printf( "[%d]  ", macro_set( macro[1], " A8\n" ) );
	printf( "[%d]\n", macro_set( macro[2], " B7\n" ) );
	printf( "const[%d]  ", const_set( "A", "_REG", 1 ) );
	printf( "[%d]  ", const_set( "BC", "_REG", 2 ) );
	printf( "[%d]  ", const_set( "DE", "_REG", 3 ) );
	printf( "[%d]  ", const_set( "A", "_REGS", 4 ) );
	printf( "[%d]\n", const_set( "A", "_REGW", 5 ) );
	printf( "<<< MACRO TEST >>>\n" );
	n = 0;
	while( macro[n][0] != 0x00 ) {
		len = macro_dt_len( macro[n] );
		if( len > 0 ) {
			bf = (char *)malloc( len + 1 );
			macro_srh( macro[n], bf );
			printf( "[%s]\n%s", macro[n], bf );
			free( bf );
		} else {
			printf( "[%s]search_error\n", macro[n] );
		}
		n++;
	}
	printf( "\n<<< CONST TEST >>>\n" );
	n = 0;
	while( *const_[n] != 0x00 ) {
		len = const_dt_len( const_[n] );
		if( len > 0 ) {
			bf = (char *)malloc( len + 1 );
			const_srh( const_[n], bf );
			len = 1;
			p = bf;
			while( (p=strchr(p,' ')) != NULL ) {
				p++;
				len++;
			}
			len /= 2;
			printf( "[%s][num %d] %s\n", const_[n], len, bf );
			free( bf );
		} else {
			printf( "[%s]search_error\n", const_[n] );
		}
		n++;
	}
	return( 0 );
}
#endif
