#include	<stdio.h>
#include	<string.h>

/* 2000/10/05 Ԉĉ߂Ă\邪A32bittH[}bgɑΉ */

/* PsɉoCgo͂邩̎w */
#define	HEX_LINE_MAX	16

#define	HEX_PAGE_MAX	3

static	char	Hex_bf[HEX_PAGE_MAX][90];	/* CSEG/DSEG/ESEG ̂Rʗp */

static	int	init_flg[5] = {1,1,1,1,1};	/* HEX_PAGE_MAXȏŏĂ */
static	unsigned	long	offset[HEX_PAGE_MAX], old_adr[HEX_PAGE_MAX];


#ifdef	PROTOTYPE1
void ihex_out(int,FILE *);
#else
void ihex_out();
#endif

#ifdef	PROTOTYPE1
void	ihex_end( FILE *fp )
#else
void	ihex_end( fp )
FILE	*fp;
#endif
{
	if( fp == NULL ) {
		printf( ":00000001FF\n" );
	} else {
		fprintf( fp, ":00000001FF\n" );
	}
}

#ifdef	PROTOTYPE1
void	ihex_out( int side, FILE *fp )
#else
void	ihex_out( side, fp )
int		side;
FILE	*fp;
#endif
{
	int		sum = 0, len, n, dt;
	char	temp[5];

	len = strlen( Hex_bf[side] );
	if( len == 0 ) {
		return;
	}
	sprintf( temp, "%02X", (len-9)/2 );
	strncpy( &Hex_bf[side][1], temp, 2 );
	for( n=1; n<len; n+=2 ) {
		strncpy( temp, &Hex_bf[side][n], 2 );
		sscanf( temp, "%x", &dt );
		sum += dt;
		sum &= 0xff;
	}
	sum = (0x100 - sum) & 0xff;
	sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", sum );
	if( fp == NULL ) {
		printf( Hex_bf[side] );
		printf( "\n" );
	} else {
		fprintf( fp, Hex_bf[side] );
		fprintf( fp, "\n" );
	}
	*Hex_bf[side] = 0x00;
}

#ifdef	PROTOTYPE1
void	ihex( int side, unsigned long adr, unsigned char dt, FILE *fp )
#else
void	ihex( side, adr, dt, fp )
int		side;
unsigned	long	adr;
unsigned	char	dt;
FILE	*fp;
#endif
{
	if( init_flg[side] ) {
		init_flg[side] = 0;
		*Hex_bf[side] = 0x00;
		offset[side] = 0L;
		old_adr[side] = adr-1L;
	}
	for( ;; ) {
		if( adr >= offset[side] ) {
			if( (adr-offset[side]) > 0xfffffL ) {
				offset[side] = (adr & 0xffff0000L);
				ihex_out( side, fp );
				sprintf( Hex_bf[side], ":  000004%04lX", (offset[side]>>16L) );
				ihex_out( side, fp );
			} else if( (adr-offset[side]) > 0xffffL ) {
				offset[side] = (adr & 0xffff0000L);
				ihex_out( side, fp );
				sprintf( Hex_bf[side], ":  000002%04lX", (offset[side]/16L) );
				ihex_out( side, fp );
			}
			break;
		} else {
			ihex_out( side, fp );
			offset[side] = 0;
			if( old_adr[side] > 0xffff ) {
				sprintf( Hex_bf[side], ":  000002%04lX", 0L );
				ihex_out( side, fp );
				old_adr[side] = 0;
			}
		}
	}
	if( *Hex_bf[side] != 0x00 ) {
		if( strlen( Hex_bf[side] ) < (9+(HEX_LINE_MAX*2)) ) {
			if( (old_adr[side]+1) == adr ) {
				sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", dt );
				old_adr[side] = adr;
				return;
			}
		}
		ihex_out( side, fp );
	}
	sprintf( Hex_bf[side], ":  %04lX00%02X", (long)(adr-offset[side]), dt );
	old_adr[side] = adr;
	return;
}

#ifdef	DEBUG_MAIN
int		main()
{
	int		n;

	for( n=1; n<36; n++ ) {
		ihex( 0, (long)n, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		ihex( 0, (long)n, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		ihex( 0, (long)n+0x12345L, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		ihex( 0, (long)n+0x212345L, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		ihex( 0, (long)n, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		ihex( 0, (long)n+0x12345L, (unsigned char)n, NULL );
	}
	for( n=0; n<36; n++ ) {
		ihex( 0, (long)n, (unsigned char)n, NULL );
	}
	ihex_out( 0, NULL );
	ihex_end( NULL );
	return( 0 );
}
#endif

