#include	<stdio.h>
#include	<string.h>

/* 2000/10/05 Ԉĉ߂Ă\邪A32bittH[}bgɑΉ */

static	char	*Copyright = "COPYRIGHT (C) 1994,2000 T.SAGAE";

/* PsɉoCgo͂邩̎w */
#define	HEX_LINE_MAX	16

#define	HEX_PAGE_MAX	3

static	char	Hex_bf[HEX_PAGE_MAX][90];	/* CSEG/DSEG/ESEG ̂Rʗp */

static	int	init_flg[5] = {1,1,1,1,1};	/* HEX_PAGE_MAXȏŏĂ */
static	int	record_type[5] = {1,1,1,1,1};
static	unsigned	long	offset[HEX_PAGE_MAX], old_adr[HEX_PAGE_MAX];



#ifdef	PROTOTYPE1
void mhex_out(int,FILE *);
#else
void mhex_out();
#endif

#ifdef	PROTOTYPE1
void	mhex_end( FILE *fp )
#else
void	mhex_end( fp )
FILE	*fp;
#endif
{
	if( fp == NULL ) {
		printf( "S9030000FC\n" );
	} else {
		fprintf( fp, "S9030000FC\n" );
	}
}

#ifdef	PROTOTYPE1
void	mhex_out( int side, FILE *fp )
#else
void	mhex_out( side, fp )
int		side;
FILE	*fp;
#endif
{
	int		sum, len, n, dt;
	char	temp[5];

	len = strlen( Hex_bf[side] );
	if( len == 0 ) {
		return;
	}
	/*	+6  check sum,address 	*/
	sprintf( temp, "%02X", (len+6-8)/2 );
	strncpy( &Hex_bf[side][2], temp, 2 );
	/*	S105006EFF503D	; 05 Ō܂ł̍v 0xff 	*/
	sum = 0;
	for( n=2; n<len; n+=2 ) {
		strncpy( temp, &Hex_bf[side][n], 2 );
		sscanf( temp, "%x", &dt );
		sum += dt;
		sum &= 0xff;
	}
	sum = (0xff - sum) & 0xff;
	sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", sum );
	if( fp == NULL ) {
		printf( Hex_bf[side] );
		printf( "\n" );
	} else {
		fprintf( fp, Hex_bf[side] );
		fprintf( fp, "\n" );
	}
	*Hex_bf[side] = 0x00;
}

#ifdef	PROTOTYPE1
int		mhex( int side, unsigned long adr, unsigned char dt, FILE *fp )
#else
int		mhex( side, adr, dt, fp )
int		side;
unsigned	long	adr;
unsigned	char	dt;
FILE	*fp;
#endif
{
	if( init_flg[side] ) {
		init_flg[side] = 0;
		*Hex_bf[side] = 0x00;
		offset[side] = 0L;
		old_adr[side] = adr-1L;
	}
	for( ;; ) {
		if( adr >= offset[side] ) {
			if( (adr-offset[side]) > 0xffffffL ) {
				offset[side] = (adr & 0xffff0000L);
				record_type[side] = 3;	/* 4byte address */
				mhex_out( side, fp );
			} else if( (adr-offset[side]) > 0xffffL ) {
				offset[side] = (adr & 0xffff0000L);
				record_type[side] = 2;	/* 3byte address */
				mhex_out( side, fp );
			}
			break;
		} else {
			mhex_out( side, fp );
			offset[side] = 0;
		}
	}
	switch( record_type[side] ) {
	case	1:	/* 2byte address */
		if( *Hex_bf[side] != 0x00 ) {
			if( strlen( Hex_bf[side] ) < (8+(HEX_LINE_MAX*2)) ) {
				if( (old_adr[side]+1) == adr ) {
					sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", dt );
					old_adr[side] = adr;
					return( 0 );
				}
			}
			mhex_out( side, fp );
		}
		sprintf( Hex_bf[side], "S1  %04lX%02X", (long)(adr-offset[side]), dt );
		break;
	case	2:	/* 3byte address */
		if( *Hex_bf[side] != 0x00 ) {
			if( strlen( Hex_bf[side] ) < (10+(HEX_LINE_MAX*2)) ) {
				if( (old_adr[side]+1) == adr ) {
					sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", dt );
					old_adr[side] = adr;
					return( 0 );
				}
			}
			mhex_out( side, fp );
		}
		sprintf( Hex_bf[side], "S2  %06lX%02X", (long)(adr-offset[side]), dt );
		break;
	case	3:	/* 4byte address */
		if( *Hex_bf[side] != 0x00 ) {
			if( strlen( Hex_bf[side] ) < (12+(HEX_LINE_MAX*2)) ) {
				if( (old_adr[side]+1) == adr ) {
					sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", dt );
					old_adr[side] = adr;
					return( 0 );
				}
			}
			mhex_out( side, fp );
		}
		sprintf( Hex_bf[side], "S3  %08lX%02X", (long)(adr-offset[side]), dt );
		break;
	}
	old_adr[side] = adr;
	return( 0 );
}

#ifdef	DEBUG_MAIN
int		main()
{
	int		n;

	for( n=1; n<36; n++ ) {
		mhex( 0, (long)n, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		mhex( 0, (long)n, (unsigned char)n, NULL );
	}
	for( n=38; n<50; n++ ) {
		if( mhex( 0, (long)n+0x12345L, (unsigned char)n, NULL ) == -1 ) {
			break;
		}
	}
	for( n=38; n<50; n++ ) {
		if( mhex( 0, (long)n+0x212345L, (unsigned char)n, NULL ) == -1 ) {
			break;
		}
	}
	mhex_out( 0, NULL );
	mhex_end( NULL );
	return( 0 );
}
#endif
